require 'socket'

require 'pp'

s = TCPSocket.open('10.42.0.47', 4201)

STRING_SIZES = [ 25, 36, 36, 36, 36, 36 ]

COLORS = [
  [0xff, 0x0f],
  [0xff, 0x00],
  [0xf0, 0x0f],
  [0xf0, 0x00],
  [0x0f, 0x0f],
  [0x0f, 0x00],
  [0x00, 0x0f],
#  [0x00, 0x00]
]

@last = []
def random_color
  ret = [0xcc, COLORS[rand(COLORS.size)]].flatten
  until @last != ret
    ret = [0xcc, COLORS[rand(COLORS.size)]].flatten
  end
  @last = ret
end

loop do
  command = ''
  STRING_SIZES.each_with_index do |size, index|
    command += ['S'.ord, index].pack('CC')
    size.times do |led|
      intensity, rg, b = random_color
      command += ['L'.ord, led, intensity, rg, b].pack('CCCCC')
    end
  end
  s.write command
end
